const app = getApp<IAppOption>();

Page({
  data: {
    background: 'transparent',

    pagination: {
      page: 1,
      pages: 1,
      count: 1,
    },
    list: [],
  },
  onLoad() {
    app.waitLogin(false, true).then(() => {
      this.getList();
    });
  },
  getList(newPage = 1) {
    wx.ajax({
      method: 'GET',
      url: `?r=shizhong/book/collect-list`,
      data: {
        page: newPage,
      },
    }).then((res) => {
      res.list.forEach((item) => {
        item.IsCollect = '1';
      });
      const list = res.page === 1 ? res.list : [...this.data.list, ...res.list];
      this.setData({
        list,
        pagination: {
          page: res.page,
          pages: res.pages,
          count: res.count,
        },
      });
    });
  },
  onReachBottom() {
    const { page, pages } = this.data.pagination;
    if (pages > page && this.data.list.length) {
      this.getList(page + 1);
    }
  },
  handleCollect(e) {
    const { index, list } = e.currentTarget.dataset;
    const { BookId } = this.data[list][index];
    wx.ajax({
      method: 'POST',
      url: '?r=shizhong/book/collect',
      data: { BookId },
    }).then(() => {
      wx.showToast({
        title: '您已收藏这本书，可在我的页查看',
        icon: 'none',
      });
      this.setData({
        [`${list}[${index}].IsCollect`]: '1',
      });
    });
  },
  handleUnCollect(e) {
    const { index, list } = e.currentTarget.dataset;
    const { BookId } = this.data[list][index];
    wx.ajax({
      method: 'POST',
      url: '?r=shizhong/book/cancel-collect',
      data: { BookId },
    }).then(() => {
      wx.showToast({
        title: '取消收藏',
        icon: 'none',
      });
      this.setData({
        [`${list}[${index}].IsCollect`]: '0',
      });
    });
  },
  handleBack() {
    wx.navigateBack();
  },
  handleDetail(e) {
    const { id } = e.currentTarget.dataset;
    app.waitLogin(false, true).then(() => {
      wx.navigateTo({
        url: `/pages/article/index?id=${id}`,
      });
    });
  },
});

export {};
