const app = getApp<IAppOption>();
let timer: number | null = 0;

Page({
  data: {
    menuButtonInfo: {},
    mobile: '',
    code: '',
    codeText: '发送验证码',
  },
  onLoad() {},
  getCode() {
    if (timer) return;
    const mobile = this.data.mobile;
    if (!mobile) {
      wx.showToast({
        title: '手机号不能为空',
        icon: 'none',
      });
      return;
    }
    // 验证手机号
    if (!/^1[3-9,]\d{9}$/.test(mobile)) {
      wx.showToast({
        title: '手机号格式不正确',
        icon: 'none',
      });
      return;
    }
    wx.ajax({
      method: 'POST',
      url: '?r=shizhong/login/send-verify-code',
      data: {
        mobile,
      },
    }).then(() => {
      wx.showToast({
        icon: 'none',
        title: '验证码已发送~',
      });
      let time = 60;
      timer = setInterval(() => {
        time--;
        this.setData({
          codeText: `${time}s后重新发送`,
        });
        if (time <= 0) {
          clearInterval(timer as number);
          timer = null;
          this.setData({
            codeText: '发送验证码',
          });
        }
      }, 1000);
    });
  },
  handleSubmit() {
    const { mobile, code } = this.data;
    if (!mobile) {
      wx.showToast({
        title: '请输入手机号',
        icon: 'none',
      });
      return;
    }
    if (!code) {
      wx.showToast({
        title: '请输入验证码',
        icon: 'none',
      });
      return;
    }
    wx.ajax({
      method: 'POST',
      url: '?r=shizhong/login/reg-login',
      data: {
        mobile,
        code,
      },
    }).then(() => {
      this.submitCallback();
    });
  },
  submitCallback() {
    app.globalData.isLogin = 1;
    wx.reLaunch({
      url: '/pages/home/index',
    });
  },
  handleBack(){
    wx.navigateBack()
  }
});

export {};
