const app = getApp<IAppOption>();
// const licia = require('miniprogram-licia');

Page({
  data: {
    nav: 0,
    percentage: 0,
    question: [] as { questionId: string; title: string; answer?: '1' | '2' }[],

    back: false,

    start: true,
    end: false,

    answerList: [
      ['非常了解', '一般了解', '完全不了解'],
      ['非常了解', '一般了解', '完全不了解'],
      ['非常了解', '一般了解', '完全不了解'],
      ['非常了解', '一般了解', '完全不了解'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['非常了解', '一般了解', '完全不了解'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
      ['很感兴趣', '一般兴趣', '不感兴趣'],
    ],
  },
  onLoad(options) {
    this.setData({
      back: options.back === '1',
    });
    app.waitLogin(true).then(() => {
      this.getList();
    });
  },
  getList() {
    wx.ajax({
      method: 'GET',
      url: '?r=shizhong/account/get-question',
      data: {},
    }).then((res) => {
      this.setData({
        question: res,
      });
    });
  },
  handleEnd() {
    app.waitLogin().then(() => {
      wx.reLaunch({
        url: '/pages/home/index',
      });
    });
  },
  // handleBtn: licia.debounce(function (e) {
  //   const { index, id } = e.currentTarget.dataset;
  //   const { question, nav } = this.data;
  //   question[index].answer = id;
  //   this.setData({
  //     question,
  //     nav: nav === question.length - 1 ? nav : nav + 1,
  //     percentage: ((nav + 1) / question.length) * 100,
  //   });
  // }, 200),
  handleBtn(e) {
    const { index, id } = e.currentTarget.dataset;
    const { question, nav } = this.data;
    // 防止重复点击
    if (question[index].answer && nav > index) return;
    question[index].answer = id;
    this.setData({
      question,
      nav: nav === question.length - 1 ? nav : nav + 1,
      percentage: ((nav + 1) / question.length) * 100,
    });
  },
  handlePrev() {
    this.setData({
      nav: this.data.nav - 1,
    });
  },
  handleSubmit() {
    const answer = this.data.question.map((item) => {
      return {
        qId: item.questionId,
        answer: item.answer,
      };
    });
    wx.ajax({
      method: 'POST',
      url: '?r=shizhong/account/answer-question',
      data: {
        answer: JSON.stringify(answer),
      },
    }).then(() => {
      this.setData({
        end: true,
      });
    });
  },
  bindtransition() {
    this.setData({
      nav: this.data.nav,
    });
  },
  catchTouchMove() {
    return false;
  },
  handleStart() {
    this.setData({ start: false });
  },
  handleBack() {
    if (this.data.end) {
      wx.navigateBack();
    } else {
      wx.showModal({
        title: '确认退出？',
        content: '还差一点就完成了，退出会清空所有答题，确认现在要退出吗？',
        cancelText: '退出',
        confirmText: '继续答题',
        success: (res) => {
          if (res.cancel) {
            if (this.data.back) {
              wx.navigateBack();
            } else {
              wx.reLaunch({
                url: '/pages/home/index',
              });
            }
          }
        },
      });
    }
  },
});

export {};
