const app = getApp<IAppOption>();

Page({
  data: {
    username: '',
    userInfo: {} as any,
  },
  onLoad() {
    app.waitLogin().then(() => {
      app.getUserInfo(this);
    });
  },
  handleFile(e) {
    const avatar = e.detail.fileUrl;
    this.setData({
      'userInfo.avatar': avatar,
    });
    this.updateUserInfo();
  },
  handleInputBlur(e) {
    this.setData({
      username: e.detail.value,
    });
  },
  handleInputBlurPass(e) {
    if (e.detail.pass) {
      this.setData({
        [`userInfo.username`]: this.data.username,
      });
      this.updateUserInfo();
    }
  },
  updateUserInfo() {
    const { avatar, username } = this.data.userInfo;
    if (!username) {
      wx.showToast({
        title: '请输入用户名',
        icon: 'none',
      });
      return;
    }
    wx.ajax({
      method: 'POST',
      url: '?r=shizhong/account/update-info',
      data: {
        userName: username,
        avatar,
      },
    }).then(() => {
      app.getUserInfo(this);
      wx.showToast({
        title: '保存成功',
        icon: 'none',
      });
    });
  },
});

export {};
